#include <iostream>
#include <fstream>
#include <cmath>
using namespace std;
int main()
{
    ifstream fi("tongbangm.inp");
    long int n,m;
    fi>>n>>m;
    long int a[n];
    for(long int i=0;i<n;i++)
    {
        fi>>a[i];
    }
    fi.close();
    ofstream fo("tongbangm.out");
    long int dem=0;
    for (long int i=0;i<n-2;i++)
        for(long int j=i+1;j<n-1;j++)
            for(long int k=j+1;k<n;k++)
                if(a[i]+a[j]+a[k]==m)
                {
                    dem++;
                    fo<<a[i]<<' '<<a[j]<<' '<<a[k]<<endl;
                }
    if(dem==0){fo<<0;}
}
